<template>
	<el-upload
		:drag="filter_conf.drag"
		:name="filter_conf.name || 'file'"
		:class="classArr[filter_conf.class || 0]"
		:show-file-list="false"
		:data="filter_conf.data"
		:on-success="handleAvatarSuccess"
		:on-preview="handlePreview"
		:on-remove="handleRemove"
		:headers="headers"
		:auto-upload="filter_conf.url ? true : false"
		:on-change="handleChange"
		:before-remove="beforeRemove"
		:on-exceed="handleExceed"
		:accept="filter_conf.accept"
		:before-upload="beforeUpload"
		:action="'/api/' + filter_conf.url"
		:multiple="filter_conf.multifile || false"
		:on-error="fileUploadFailed"
		v-loading.fullscreen.lock="fullscreenLoading"
		element-loading-spinner="el-icon-loading"
		element-loading-background="rgba(0, 0, 0, 0.7)"
		element-loading-text="图片上传中..."
	>
		<img v-if="filter_conf.img_src && !filter_conf.type" :src="filter_conf.img_src" alt="">
		<el-row
			v-else-if="filter_conf.type === 'text'"
			class="talincenter"
			style="color:#3990e9;"
		>{{filter_conf.text || '上传'}}</el-row>
		<el-row v-else-if="filter_conf.type === 'button'">
			<el-button type="primary" size="mini" plain>
				{{filter_conf.text || ((filter_conf.files || filter_conf.file) ? '重新上传' : '上传附件')}}
				<i
					class="el-icon-upload el-icon--right"
				></i>
			</el-button>
			<span
				@click="none"
				v-if="!filter_conf.files && filter_conf.file"
				class="marginLeft8"
			>{{filter_conf.file.name}}</span>
			<span
				v-else-if="filter_conf.files"
				v-for="(file,index) in filter_conf.files"
				:key="index"
				@click="none"
				class="marginLeft8"
			>{{file.name}}</span>
		</el-row>
	</el-upload>
</template>

<script>
import { Loading } from 'element-ui'
export default {
	mixins: [$mixin],
	props: ['conf'],
	data() {
		return {
			classArr: ['w160h130', 'w130h160', 'alginLeft'],
			fullscreenLoading: false,
			timeStamp: 0
		}
	},
	computed: {
		filter_conf() {
			return this.conf || {}
		},
		headers() {
			return this.userInfo
				? {
						token: this.userInfo.token
				  }
				: {}
		}
	},
	methods: {
		none() {},
		handleRemove(file, fileList) {
			console.log(file, fileList)
		},
		handlePreview(file) {
			console.log(file)
		},
		beforeUpload() {
			this.timeStamp = Date.parse(new Date())
			this.fullscreenLoading = true
			return true
		},
		handleChange(file) {
			if (!this.filter_conf.url) {
				if (!this.filter_conf.file || !this.filter_conf.multifile) {
					this.$set(this.filter_conf, 'file', file.raw)
				} else {
					let arr = this.filter_conf.files || [
						utils.deepClone(this.filter_conf.file)
					]
					arr.push(file.raw)
					this.$set(this.filter_conf, 'files', arr)
				}
				this.$set(this.filter_conf, 'img_src', URL.createObjectURL(file.raw))
				$event_bus.$emit('fileChange', { conf: this.filter_conf })
			}
		},
		handleExceed(files, fileList) {
			this.$message.warning(
				`当前限制选择 3 个文件，本次选择了 ${
					files.length
				} 个文件，共选择了 ${files.length + fileList.length} 个文件`
			)
		},
		beforeRemove(file, fileList) {
			return this.$confirm(`确定移除 ${file.name}？`)
		},
		handleAvatarSuccess(res, file) {
			if (this.timeStamp - Date.parse(new Date()) < 1000) {
				setTimeout(() => {
					this.fullscreenLoading = false
				}, 1500)
			} else {
				this.fullscreenLoading = false
			}
			if (parseInt(res.code) !== 0) {
				this.alert(res.msg)
				return false
			} else if (!res.data) {
				console.log(this.filter_conf)
				this.alert({
					message: '上传成功',
					type: 'success',
					onClose: () => {
						$event_bus.$emit(
							this.filter_conf.uploadCallBack || 'uploadSuccess',
							{}
						)
					}
				})
				return false
			}
			this.$set(this.filter_conf, 'file', file.raw)
			this.$set(this.filter_conf, 'img_src', URL.createObjectURL(file.raw))
			res.data &&
				$event_bus.$emit(this.filter_conf.uploadCallBack || 'uploadSuccess', {
					res,
					conf: this.filter_conf,
					file
				})
		},
		fileUploadFailed(err) {
			this.alert('文件上传失败，请重试！')
		}
	}
}
</script>

<style lang="less">
.alginLeft {
	display: flex;
	justify-content: flex-start;
	align-items: center;
}
.w130h160 {
	.el-upload-dragger,
	img {
		max-width: 8.125rem;
		height: 10rem;
	}
}
.w160h130 {
	.el-upload-dragger,
	img {
		max-width: 10rem;
		height: 6.875rem;
	}
	display: flex;
	justify-content: center;
}
.el-loading-spinner {
	p {
		text-align: center;
		font-size: 0.75rem !important;
		color: #ffffff !important;
	}
	i {
		font-size: 1.5rem;
		color: #ffffff;
	}
}
</style>
